package huffman;

public class Case implements Comparable<Case>{

    private int painScale;
    private String name;
    private long arrivalTime;

    public Case(int painScale, String name) {
        this.painScale = painScale;
        this.name = name;
        this.arrivalTime = System.currentTimeMillis();
    }

    @Override
    public int compareTo(Case other) {
        if (this.painScale == other.painScale) {
            return Long.compare(this.arrivalTime, other.arrivalTime);
        }
        // NEGATIVE! So that low pain -> low priority
        return -Integer.compare(this.painScale, other.painScale);
    }

    @Override
    public String toString() {
        return "Case{" +
                "name='" + name + '\'' +
                ", arrivalTime=" + arrivalTime +
                '}';
    }
}
